VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Chat 
   Caption         =   "Client"
   ClientHeight    =   8520
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10515
   LinkTopic       =   "Form1"
   ScaleHeight     =   568
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   701
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   6120
      Top             =   6240
   End
   Begin MSWinsockLib.Winsock SockServer 
      Index           =   0
      Left            =   6000
      Top             =   4680
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock SockClient 
      Left            =   6000
      Top             =   4200
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox TextIn 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   5400
      Width           =   6975
   End
   Begin VB.TextBox Log 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5295
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   6975
   End
End
Attribute VB_Name = "Chat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ### Oppdatert 13.02.2006 ###
' - Fikset formatering i formfil
' - La til segmenteringstegn etter hver sendte linje
' ###

Public Sub Command(Text As String)

    ' Command
    Dim A, B, IP$, MES, C%
    
    A = Split(Text, " ", 2)
    
    Select Case LCase(A(0))
    Case "/help"
    
        PrintText Log, "/help"
        PrintText Log, "Functions that can be used all the time:"
        PrintText Log, "/clear [file]           Clears log ot logon-script"
        PrintText Log, "/get [file]             Will open log or logon-script"
        PrintText Log, "/exit                   Exit the program"
        PrintText Log, "/script [line]          Proceses a script line"
        PrintText Log, "/connect [ip]           Connects to a server"
        PrintText Log, "/nick [name]            Changes the nickname"
        PrintText Log, "/bind                   Creates a server"
        PrintText Log, "/write [file] [line]    Writes to log or logon-script"
        PrintText Log, ""
        PrintText Log, "Functions only available in connected mode:"
        PrintText Log, "/setuser [user]         Give a user administrative rights"
        PrintText Log, "/priv [user] [message]  Sends a private message"
        PrintText Log, "/disconnect             Disconnects from the server"
        PrintText Log, "/list                   Lists all users"
        PrintText Log, "/kick [user]            Kills a user"
        PrintText Log, "/rpc [user] [line]      Sends a script line"
        PrintText Log, ""
        PrintText Log, "Note! /kick and /rpc is only available for"
        PrintText Log, "server or users with administrative rights."
        Exit Sub
    
    Case "/write"
    
        On Error GoTo 100
        
        B = Split(A(1), " ", 2)
        
        Open App.Path & "\" & B(0) & ".txt" For Append As #1
            Print #1, B(1)
        Close #1
        
        PrintText Log, Text
        Exit Sub
        
100:
        PrintText Log, "Error in writing to file"
        Exit Sub
    
    Case "/clear"
    
        If Dir(App.Path & "\" & A(1) & ".txt") = "" Then
            PrintText Log, Text
            PrintText Log, "File don't exist"
            Exit Sub
        End If
        
        Kill App.Path & "\" & A(1) & ".txt"
        PrintText Log, A(1) & " is deleted, time is " & Now
        Exit Sub
    
    Case "/get":
    
        If Len(Dir(App.Path & "\" & A(1) & ".txt")) = 0 Then
            PrintText Log, Text: PrintText Log, "File don't exist": Exit Sub
            ShellExecute Me.hwnd, vbNullString, App.Path & "\" & A(1) & ".txt", vbNullString, "C:\", SW_SHOWNORMAL
            Exit Sub
        End If
    
    Case "/exit"
        
        PrintText Log, "/exit"
        Unload Me
    
    Case "/setuser"
    
        B = Split(A(1), " ")
        C = SearchForUser(CStr(B(0)))
        
        If C <= 0 Then
            PrintText Log, "User don't exist"
            Exit Sub
        End If
        
        If UserInfo(C) = 0 Then
            UserInfo(C) = 1
            SockServer(C).SendData "USERINFO 3" & vbNullChar: DoEvents
            PrintText Log, A(1) & " have now admnin right"
        Else
            UserInfo(C) = 0
            SockServer(C).SendData "USERINFO 1" & vbNullChar: DoEvents
            PrintText Log, A(1) & " have now only user right"
        End If
        
        Exit Sub
    
    Case "/script"
        
        PrintText Log, CStr(A(1))
        DoLine A(1), Log
        Exit Sub
    
    Case "/disconnect"
    
        If SockClient.State <> sckConnected Then
            PrintText Log, "Can't disconnect when not connected"
            Exit Sub
        End If
    
        SockClient.Close
        PrintText Log, "Disconnected"
    
    Case "/connect"
    
        ' Treat array as a a single variable
        ReDim ExtraData(1 To 1)
     
        SerStat = 0
        IP = A(1)
        PrintText Log, "Connecting to " & IP & ", at port " & Port
        SockClient.Close
        SockClient.Connect IP, Port
        Exit Sub
        
    Case "/priv"
    
        If SerStat = 2 Then
            B = Split(A(1), " ", 2)
            C = SearchForUser(CStr(B(0)))
            
            If C <= 0 Then
                Exit Sub
            End If
            
            SockServer(C).SendData "MSG " & UserName & " " & B(1) & vbNullChar: DoEvents
            Exit Sub
        End If
        
        MES = Split(A(1), " ", 2)
        SockClient.SendData "PRIV " & MES(0) & " " & MES(1) & vbNullChar: DoEvents
        Exit Sub
    
    Case "/nick"
    
        MES = Trim(A(1))
        
        If SockClient.State = sckConnected Then
            SockClient.SendData "CHANGE " & MES & vbNullChar
            DoEvents
        Else
            UserName = MES
            PrintText Log, "Username set to " & UserName
        End If
    
    Exit Sub
    Case "/bind"
    
        SerStat = 2
        SockServer(0).Close
        SockServer(0).LocalPort = Port
        SockServer(0).Listen
        PrintText Log, "Server started at " & Now
        Exit Sub
        
    Case "/list"
    
        If SerStat = 2 Then
        
            If SockServer.Count - 1 <= 0 Then
                Exit Sub
            End If
            
            C = C + 1
            PrintText Log, C & ". " & UserName
        
            For B = 1 To SockServer.Count - 1
                If SockServer(B).Tag <> "" And SockServer(B).State = sckConnected Then
                    C = C + 1
                    PrintText Log, C & ". " & SockServer(B).Tag
                    DoEvents
                End If
            Next
        
            Exit Sub
        End If
    
        SockClient.SendData "LIST" & vbNullChar
        DoEvents
        Exit Sub
    
    Case "/kick"
    
        If SerStat = 2 Then
        
            ' User is server
            KickUser CStr(A(1))
        
        ElseIf SerStat = 3 Then
        
            ' User is moderator, server accept commands
            SockClient.SendData "RPC " & UserName & " KICK " & CStr(A(1)) & vbNullChar
            DoEvents
    
        Else
            PrintText Log, "Denied"
        End If
    
    Case "/rpc"
    
        If SerStat = 2 Then
        
            B = Split(A(1), " ", 2)
            C = SearchForUser(CStr(B(0)))
            
            If C <= 0 Then
                PrintText Log, "User don't exist"
                Exit Sub
            End If
            
            SockServer(C).SendData "RPC " & UserName & " " & B(1) & vbNullChar
            DoEvents
            Exit Sub
        
        ElseIf SerStat = 3 Then
        
            SockClient.SendData "SENDRPC " & A(1) & vbNullChar
            DoEvents
            Exit Sub
        
        End If
    End Select

    If SockClient.State <> sckConnected Then
        
        If SerStat = 2 Then
            BroadCastMessage UserName, Text
            Exit Sub
        End If
        
        PrintText Log, "ERROR: Not connected to any server"
        
    Else
    
        If SerStat = 0 Then
            PrintText Log, "ERROR: Not logged in"
            Exit Sub
        End If
        
        SockClient.SendData "SEND " & Text & vbNullChar
        DoEvents
        
    End If

End Sub

Public Sub AskForName()

    PrintText Log, "What is your name?"
    TextIn.SetFocus
    
    Do Until AnswerGiven
        Sleep 10
        DoEvents
    Loop

End Sub

Private Sub Form_Load()

    ReDim ExtraData(1)

    Show
    AskForName
    
    PrintText Log, "Welcome to Client Chat v.1.0, " & UserName
    PrintText Log, "Programmed by Kristian.S.Stangeland" & vbNewLine
    PrintText Log, "Write /connect [ip or domain] to begin to chat"
    PrintText Log, "Or write /bind to create a server"

End Sub

Private Sub Form_Resize()

    If Me.WindowState = 1 Then Exit Sub
    Log.Width = Me.ScaleWidth - 8 - Log.Left
    Log.Height = Me.ScaleHeight - 10 - Log.Top - TextIn.Height
    TextIn.Width = Log.Width
    TextIn.Top = Log.Top + Log.Height

End Sub

Private Sub Form_Unload(Cancel As Integer)

    PrintText Log, "Program ended, time is " & Now
    End

End Sub

Private Sub SockServer_ConnectionRequest(Index As Integer, ByVal requestID As Long)

    Dim A&
    
    A = GetFreeSocket
    SockServer(A).Accept requestID
    SockServer(A).Tag = ""

End Sub

Private Sub SockServer_DataArrival(Index As Integer, ByVal bytesTotal As Long)

    Dim sData As String, Tell As Long, vLines
    
    ' Retrieve the data
    SockServer(Index).GetData sData
    
    ' As several lines might have been sent in the process, we got to split the retrieved data
    vLines = Split(ExtraData(Index) & sData, vbNullChar)
    
    ' Process all the lines beside the last one (which is the superfluous information)
    For Tell = LBound(vLines) To UBound(vLines) - 1
        ProcessServerLine CStr(vLines(Tell)), Index
    Next

    ' Save the remaining information
    ExtraData(Index) = vLines(UBound(vLines))
    
End Sub

Private Sub SockServer_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)

    PrintText Log, "ERROR " & Number & ": " & Description

End Sub

Private Sub TextIn_KeyDown(KeyCode As Integer, Shift As Integer)

    If KeyCode = 13 Then
    
        If TextIn.Text = "" Then
            Exit Sub
        End If
        
        If AnswerGiven = False Then
            UserName = Trim(TextIn.Text)
            AnswerGiven = True
            TextIn.Text = ""
            Exit Sub
        End If
        
        Command TextIn.Text
        TextIn.Text = ""
        Exit Sub
        
    End If

End Sub

Private Sub SockClient_Close()

    SerStat = 0
    
    PrintText Log, "Disconnected"

End Sub

Private Sub SockClient_Connect()

    PrintText Log, "Connected... logging in..."
    
    SockClient.SendData "USER " & UserName & vbNullChar
    DoEvents

End Sub

Private Sub SockClient_DataArrival(ByVal bytesTotal As Long)

    Dim sData As String, Tell As Long, vLines
    
    ' Retrieve the data
    SockClient.GetData sData
    
    ' As several lines might have been sent in the process, we got to split the retrieved data
    vLines = Split(ExtraData(1) & sData, vbNullChar)
    
    ' Process all the lines beside the last one (which is the superfluous information)
    For Tell = LBound(vLines) To UBound(vLines) - 1
        ProcessClientLine CStr(vLines(Tell))
    Next

    ' Save the remaining information
    ExtraData(1) = vLines(UBound(vLines))

End Sub

Public Sub ProcessServerLine(sLine As String, Index As Integer)

    Dim A, B, C%, D$
    
    A = Split(sLine, " ", 2)
    
    Select Case UCase(A(0))
    Case "CHANGE"
        
        If SearchForUser(CStr(A(1))) = 0 Then
            SockServer(Index).Tag = CStr(A(1))
            SockServer(Index).SendData "CHANGE " & CStr(A(1)) & vbNullChar
            DoEvents
        Else
            SockServer(Index).SendData "SYSMSG Username alredy exist" & vbNullChar
            DoEvents
        End If
    
    Case "USER"
    
        If SearchForUser(CStr(A(1))) = 0 Then
        
            SockServer(Index).Tag = A(1)
            SockServer(Index).SendData LOGIN_SUCCESS & vbNullChar
            DoEvents
            
            If Dir(App.Path & "\Login.txt") <> "" Then
                Open App.Path & "\Login.txt" For Input As #1
                    Do Until EOF(1)
                        Line Input #1, D
                        SockServer(Index).SendData "RPC " & UserName & " " & D & vbNullChar
                        DoEvents
                    Loop
                Close #1
            End If
        
        Else
            SockServer(Index).SendData LOGIN_USERNAME_IN_USE & vbNullChar: DoEvents
            SockServer(Index).Close
        End If
    
    Case "SEND"
        BroadCastMessage CStr(SockServer(Index).Tag), CStr(A(1))
        
    Case "PRIV"
        
        B = Split(A(1), " ", 2)
        C = SearchForUser(CStr(B(0)))
        
        If LCase(B(0)) = LCase(UserName) Then
            FlashForm Me
            PrintText Log, SockServer(Index).Tag & ": " & B(1)
            Exit Sub
        End If
        
        If C <= 0 Then
            Exit Sub
        End If
        
        SockServer(C).SendData "MSG " & SockServer(Index).Tag & " " & CStr(B(1)) & vbNullChar
        DoEvents
    
    Case "LIST"
    
        If SockServer.Count - 1 <= 0 Then Exit Sub
        
        B = B + 1
        SockServer(Index).SendData "LIST " & B & " " & UserName & vbNullChar
        DoEvents
        
        For A = 1 To SockServer.Count - 1
            If SockServer(A).Tag <> "" And SockServer(A).State = sckConnected Then
                B = B + 1
                SockServer(Index).SendData "LIST " & B & " " & SockServer(A).Tag & vbNullChar
                DoEvents
            End If
        Next
    
    Case "RPC"
        
        If UserInfo(Index) <> 0 Then
            DoLine A(1), Log
        End If
        
    Case "SENDRPC"
    
        If UserInfo(Index) = 0 Then
            Exit Sub
        End If
        
        B = Split(A(1), " ", 2)
        C = SearchForUser(CStr(B(0)))
        
        If LCase(B(0)) = LCase(UserName) Then
            DoLine B(1), Log
            Exit Sub
        End If
        
        If C <= 0 Then
            SockServer(Index).SendData "SYSMSG User don't exist" & vbNullChar
            DoEvents
            Exit Sub
        End If
        
        SockServer(C).SendData "RPC " & SockServer(Index).Tag & " " & B(1) & vbNullChar
        DoEvents
    
    End Select


End Sub

Public Sub ProcessClientLine(sLine As String)

    Dim A As Variant

    ' Whether or not we're already logged in
    If SerStat = 0 Then
    
        Select Case Val(sLine)
        Case LOGIN_SUCCESS: PrintText Log, "You are logged in": SerStat = 1
        Case LOGIN_SERVER_FULL: PrintText Log, "Server is full!": SockClient.Close
        Case LOGIN_USERNAME_IN_USE: PrintText Log, "Username is in use, change it!": SockClient.Close
        End Select
        
    Else
        
        ' Other commands when logged in
        A = Split(sLine, " ", 3)
        
        Select Case A(0)
        Case "MSG"
            ' Someone has said something
            FlashForm Me
            PrintText Log, A(1) & ": " & A(2)
            
        Case "LIST"
            PrintText Log, A(1) & ". " & A(2)
            
        Case "RPC"
            DoLine A(2), Log, CStr(A(1))
            
        End Select
        
        A = Split(sLine, " ", 2)
        
        Select Case A(0)
        Case "CHANGE"
            UserName = A(1)
            PrintText Log, "Username set to " & UserName
        
        Case "SYSMSG"
            PrintText Log, "ERROR: " & A(1)
            
        Case "USERINFO"
            SerStat = Val(A(1))
            If SerStat = 3 Then PrintText Log, "You have got administrative rights"
            If SerStat = 1 Then PrintText Log, "You have got only user rights"
            
        End Select
        
    End If

End Sub

Private Sub SockClient_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)

    PrintText Log, "ERROR " & Number & ": " & Description
    SockClient.Close

End Sub

Private Sub Timer1_Timer()
    
    DoLine Timer_Line, Log

End Sub
